unit DirCleaner;


interface


uses Windows, Classes, SysUtils, Forms, Dialogs, ProgressWin,
  WinUtils, StrUtils;

procedure ProcessDirClean(ATypes, ADirs: TStrings);

implementation


type

  TCleanThread = class(TThread)
  private
    FOnce: boolean;
  protected
    procedure Execute; override;
  end;


var Types, Dirs: TStrings;
  Thrd: TCleanThread;
  FilesDel: LongInt;
  Results:TStringList;

procedure TCleanThread.Execute;
var
  I, J: LongInt;
  Files, MainFil: TStringList;
  FSize, TotSize: Int64;
  ProgRise, RealProg: single;

begin
  while (not Terminated) and (not FOnce) do
  begin
    FOnce := true;
    FilesDel := 0;
    Files := TStringList.Create;
    MainFil := TStringList.Create;
    for I := 0 to Dirs.Count - 1 do
       for J := 0 to Types.Count - 1 do
        begin
          AdvBuildFileList(Dirs[I] + '\*' + Types[J], faAnyFile, Files,
            [flFullNames, flRecursive]);
          MainFil.AddStrings(Files);
        end;

    RealProg := 0;
    ProgRise := 100 / (MainFil.Count+1);
    TotSize := 0;

    Results.Clear;
    for J := 1 to Dirs.Count*2 do
      Results.Insert(0, '0');

    for I := 0 to MainFil.Count - 1 do
    begin
      if FileExists(MainFil[I])then
      begin
      FSize := FileSize(MainFil[I]);
      if DeleteFile(MainFil[I])then
      begin
      TotSize := TotSize + FSize;
      for J := 0 to Dirs.Count - 1 do
        if AnsiContainsText(MainFil[I], Dirs[J]) then
        begin
          Results[J*2] := IntToStr(StrToInt(Results[J*2]) + FSize);
          Results[J*2+1] := IntToStr(StrToInt(Results[J*2+1])+1);
        end;
      end;
      end;

      RealProg := RealProg + ProgRise;
      if RealProg < 99 then
        ProgressForm.SetProgress(Round(RealProg));

    end;

    Results.Insert(0, IntToStr(TotSize));
    Results.Insert(0, IntToStr(MainFil.Count));

    Files.Free;
    MainFil.Free;
    ProgressForm.SetProgress(100);
  end;
end;


procedure ProcessDirClean(ATypes, ADirs: TStrings);
var S: string;
  I: LongInt;
begin
  if (ADirs.Count = 0) then
  begin
    MessageDlg('Directory Cleaner Error :' + #10 +
      'Directories not defined!', mtError,
      [mbOK], 0);
    Exit;
  end;

  if (ATypes.Count = 0)then
  begin
      MessageDlg('Directory Cleaner Error :' + #10 +
      'File Types not defined!', mtError,
      [mbOK], 0);
    Exit;
  end;

  Types := ATypes;
  Dirs := ADirs;

  Results := TStringList.Create;

  if ProgressForm = nil then
    Application.CreateForm(TProgressForm, ProgressForm);

  Thrd := TCleanThread.Create(true);
  Thrd.Resume;

  ProgressForm.ShowProgress('Processing Directory Cleaner', '', 0, 100,
    false);

  Thrd.Free;

  S := 'Directory Cleaner Completed' + #10#10 +
    Format('Deleted total %d files of size: %.0n Bytes ( %n kB ; %n MB)',
    [StrToInt(Results[0]), StrToInt(Results[1]) / 1,
    StrToInt(Results[1]) / 1024, StrToInt(Results[1]) / 1024 / 1024]);
  S := S + #10 + 'Directory Statictics :' + #10;
  for I := 0 to Dirs.Count - 1 do
  begin
    S := S + Dirs[I];
    S:=S+#9;
    S := S + Format('%d files of size: %.0n Bytes ( %n kB ; %n MB)',
      [StrToInt(Results[2 + I*2+1]),
      StrToInt(Results[2 + I*2]) / 1,
      StrToInt(Results[2 + I*2]) / 1024, StrToInt(Results[2 + I*2]) / 1024 / 1024])
        + #10;
  end;

  MessageDlg(S + #10 +
    '                                                       ',
    mtInformation, [mbOK], 0);

  Results.Free;

end;



end.
