unit SourceSize;

interface


uses Windows, Classes, SysUtils, Forms, Dialogs, ProgressWin,
  WinUtils, StrUtils;

procedure ProcessSrcSize(ATypes, ADirs: TStrings; AAll: boolean);

implementation


type

  TSrcThread = class(TThread)
  private
    FOnce: boolean;
  protected
    procedure Execute; override;
  end;


var Types, Dirs: TStrings;
  AllTypes: boolean;
  Results: TStringList;
  Thrd: TSrcThread;
  FilesCopied: LongInt;

procedure TSrcThread.Execute;
var
  I, J: LongInt;
  Files, MainFil: TStringList;
  FSize, TotSize: Int64;
  ProgRise, RealProg: single;

begin
  while (not Terminated) and (not FOnce) do
  begin
    FOnce := true;
    FilesCopied := 0;
    Files := TStringList.Create;
    MainFil := TStringList.Create;
    for I := 0 to Dirs.Count - 1 do
    begin
      if not AllTypes then
        for J := 0 to Types.Count - 1 do
        begin
          AdvBuildFileList(Dirs[I] + '\*' + Types[J], faAnyFile, Files,
            [flFullNames, flRecursive]);
          MainFil.AddStrings(Files);
        end
      else
      begin
        AdvBuildFileList(Dirs[I] + '\*.*', faAnyFile, Files,
          [flFullNames, flRecursive]);
        MainFil.AddStrings(Files);
      end;
    end;

    RealProg := 0;
    ProgRise := 100 / (MainFil.Count+1);
    TotSize := 0;

    Results.Clear;
    for J := 0 to Dirs.Count - 1 do
      Results.Insert(0, '0');

    for I := 0 to MainFil.Count - 1 do
    begin
      if FileExists(MainFil[I])then
      begin
      FSize := FileSize(MainFil[I]);
      TotSize := TotSize + FSize;

      for J := 0 to Dirs.Count - 1 do
        if AnsiContainsText(MainFil[I], Dirs[J]) then
        begin
          Results[J] := IntToStr(StrToInt(Results[J]) + FSize);
        end;
      end;

      RealProg := RealProg + ProgRise;
      if RealProg < 99 then
        ProgressForm.SetProgress(Round(RealProg));

    end;

    Results.Insert(0, IntToStr(TotSize));
    Results.Insert(0, IntToStr(MainFil.Count));

    Files.Free;
    MainFil.Free;
    ProgressForm.SetProgress(100);
  end;
end;


procedure ProcessSrcSize(ATypes, ADirs: TStrings; AAll: boolean);
var S: string;
  I: LongInt;
begin
  if (ADirs.Count = 0) then
  begin
    MessageDlg('Source Size Counter Error :' + #10 +
      'Directories not defined!', mtError,
      [mbOK], 0);
    Exit;
  end;

  if (ATypes.Count = 0) and (not AAll) then
  begin
    MessageDlg('Source Size Counter Error :' + #10 +
      'File Types not defined!', mtError,
      [mbOK], 0);
    Exit;
  end;

  Types := ATypes;
  Dirs := ADirs;
  AllTypes := AAll;

  Results := TStringList.Create;

  if ProgressForm = nil then
    Application.CreateForm(TProgressForm, ProgressForm);

  Thrd := TSrcThread.Create(true);
  Thrd.Resume;

  ProgressForm.ShowProgress('Processing Source Size Counter', '', 0, 100,
    false);

  Thrd.Free;

  S := 'Source Size Counter Completed' + #10#10 +
    Format('Total %d files of size: %.0n Bytes ( %n kB ; %n MB)',
    [StrToInt(Results[0]), StrToInt(Results[1]) / 1,
    StrToInt(Results[1]) / 1024, StrToInt(Results[1]) / 1024 / 1024]);
  S := S + #10 + 'Directory Sizes :' + #10;
  for I := 0 to Dirs.Count - 1 do
  begin
    S := S + Dirs[I];
    S:=S+#9#9;
    S := S + Format('%.0n Bytes ( %n kB ; %n MB)',
      [StrToInt(Results[2 + I]) / 1,
      StrToInt(Results[2 + I]) / 1024, StrToInt(Results[2 + I]) / 1024 / 1024])
        + #10;
  end;

  MessageDlg(S + #10 +
    '                                                       ',
    mtInformation, [mbOK], 0);

  Results.Free;

end;


end.

