unit ProgressWin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ProgressCyl, ExtCtrls, Menus, ComCtrls;

type
  TProgressForm = class(TForm)
    Panel1: TPanel;
    GroupProg: TGroupBox;
    LabProcess: TLabel;
    BtnCancel: TButton;
    MainMenu1: TMainMenu;
    u1: TMenuItem;
    ProgBar: TProgressBar;
    procedure BtnCancelClick(Sender: TObject);
    procedure ProgCylProgressDone(Sender: TObject);
  private

    { Private declarations }
  public

    procedure ShowProgress(Caption,Process:string;Prog,ProgMax:LongInt;
      Cancel:boolean);
    procedure IncProgress(Amount:LongInt);
    procedure DecProgress(Amount:LongInt);
    procedure SetProgress(Pos:LongInt);
    procedure ProcessName(AName:string);

    { Public declarations }
  end;

var
  ProgressForm: TProgressForm;

implementation

{$R *.dfm}

procedure TProgressForm.ShowProgress(Caption,Process:string;Prog,ProgMax:LongInt;Cancel:boolean);
begin
 GroupProg.Caption:=Caption;
 LabProcess.Caption:=Process;
 ProgBar.Position:=Prog;
 ProgBar.Max:=ProgMax;
 BtnCancel.Visible:=Cancel;
 ShowModal;
end;


procedure TProgressForm.BtnCancelClick(Sender: TObject);
begin
 Close;
end;

procedure TProgressForm.IncProgress(Amount:LongInt);
begin
 ProgBar.Position:=ProgBar.Position+Amount;
 if ProgBar.Position>=ProgBar.Max then
  ProgCylProgressDone(nil);
end;

procedure TProgressForm.DecProgress(Amount:LongInt);
begin
 ProgBar.Position:=ProgBar.Position-Amount;
 if ProgBar.Position>=ProgBar.Max then
  ProgCylProgressDone(nil);
end;

procedure TProgressForm.SetProgress(Pos:LongInt);
begin
 ProgBar.Position:=Pos;
 if ProgBar.Position>=ProgBar.Max then
  ProgCylProgressDone(nil);
end;

procedure TProgressForm.ProcessName(AName:string);
begin
 LabProcess.Caption:=AName;
end;


procedure TProgressForm.ProgCylProgressDone(Sender: TObject);
begin
 LabProcess.Caption:='Progress Complete';
 Sleep(200);
 Close;
end;

end.
