unit TableWin;



interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Grids, VampyreAboutDlg, ValEdit, WinUtils, TableMain,
  Registry, FileVFormat, StrUtils,Colors,
  ExtCtrls, StdCtrls, Buttons, XPMenu, ImgList, ComCtrls,
   XPMan,Images, ToolWin;


type

  TExportTable=(etText,etCSVxp,etCSV97);

  TTableForm = class(TForm)
    Grid: TStringGrid;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open: TMenuItem;
    Save: TMenuItem;
    SaveAs: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Pages: TPageControl;
    Props: TTabSheet;
    PropEdit: TValueListEditor;
    OpenD: TOpenDialog;
    SaveD: TSaveDialog;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel3: TPanel;
    Button1: TButton;
    FontD: TFontDialog;
    Comments: TMemo;
    Label1: TLabel;
    N2: TMenuItem;
    Export1: TMenuItem;
    Edit1: TMenuItem;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    N3: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Print1: TMenuItem;
    ExportText: TMenuItem;
    N4: TMenuItem;
    Find1: TMenuItem;
    Replace1: TMenuItem;
    FindD: TFindDialog;
    ReplaceD: TReplaceDialog;
    PrintD: TPrintDialog;
    ExportD: TSaveDialog;
    ExcelXPCSVfile1: TMenuItem;
    Excel972000CSVfile1: TMenuItem;
    XPMan: TXPManifest;
    GroupBox1: TGroupBox;
    CheckCompress: TCheckBox;
    ControlBar1: TControlBar;
    Delete1: TMenuItem;
    Panel4: TPanel;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    Panel5: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton11: TSpeedButton;
    Panel1: TPanel;
    Panel2: TPanel;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    Panel6: TPanel;
    SpeedButton14: TSpeedButton;
    SelPanel: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    SpdTogglePages: TSpeedButton;
    XPMenu: TXPMenu;
    procedure About1Click(Sender: TObject);
    procedure GridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure PropEditValidate(Sender: TObject; ACol, ARow: Integer;
      const KeyName, KeyValue: string);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PropEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SaveAsClick(Sender: TObject);
    procedure OpenClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure GridKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure GridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GridKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GridMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure GridDblClick(Sender: TObject);
    procedure GridClick(Sender: TObject);
    procedure GridColumnMoved(Sender: TObject; FromIndex,
      ToIndex: Integer);
    procedure GridRowMoved(Sender: TObject; FromIndex, ToIndex: Integer);
    procedure CheckCompressClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Print1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure Replace1Click(Sender: TObject);

    procedure FindText(Sender: TObject);
    procedure ReplaceDReplace(Sender: TObject);
    procedure ExportTextClick(Sender: TObject);
    procedure ExcelXPCSVfile1Click(Sender: TObject);
    procedure Excel972000CSVfile1Click(Sender: TObject);
    procedure SetsEditValidate(Sender: TObject; ACol, ARow: Integer;
      const KeyName, KeyValue: String);
    procedure Delete1Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton11Click(Sender: TObject);
    procedure SpeedButton12Click(Sender: TObject);
    procedure SpeedButton13Click(Sender: TObject);
    procedure SpeedButton14Click(Sender: TObject);
    procedure SpdTogglePagesClick(Sender: TObject);
    procedure GridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    AModTable: TTable;
    IsModal: boolean;
    FindPos: LongInt;
    SelImg:TImage;
    { Private declarations }
  public
    FileName: string;
    Table: TTable;
    Editing: boolean;
    Store: string;
    StoreArr: TDynStrGrid;
    Modified: boolean;

    procedure AssignTable;
    procedure AssignGrid;
    procedure AssignMeasuresTab;
    procedure AssignMeasuresGrid;
    procedure ResetMeasures;
    procedure Update; reintroduce;
    procedure RegFile;
    procedure UpdatePos;
    function GridRect(c1, r1, c2, r2: LongInt): TGridRect;
    function SetGridPt(c, r: LongInt): TGridRect;
    function CheckGR(R: TGridRect): TGridRect;
    procedure CopySel;
    procedure Paste;
    procedure DeleteSel;
    procedure Cut;
    function PtInRect(X,Y:LongInt;R:TGridRect):boolean;

    procedure ModalShow(ATable: TTable);
    procedure ModalHide(ATable: TTable = nil);

    procedure ExportTable(Exp:TExportTable);

    { Public declarations }
  end;

const

  sUntit = 'untitled.vdt';
  sApp = ' Vampyre Table Manager ';
  sAppVer = 'Version 0.39  13.12.2002';
  sAppName = 'Table Manager';

var
  TableForm: TTableForm;

implementation

{$R *.dfm}

procedure TTableForm.FormCreate(Sender: TObject);
begin
  RegFile;
  Filename := sUntit;
  Table := TTable.Create;
//  SaveD.InitialDir := ExeDir;
//  OpenD.InitialDir := ExeDir;
  SelImg:=TImage.Create();
  SelImg.BitCount:=24;
  SelImg.Resize(8,8);
  SelImg.FillRect(SelImg.Bounds,colRed);
  SelImg.SetAlphaChannel(75);

  Grid.DoubleBuffered:=true;

  AssignGrid;
  Update;
  ResetMeasures;

  if FileExists(ParamStr(1)) then
  begin
    Table.LoadFromFile(ParamStr(1));
    AssignGrid;
    AssignMeasuresGrid;
    Filename := ParamStr(1);
    Update;

  end;

  //WindowState := wsMaximized;
end;

procedure TTableForm.FormDestroy(Sender: TObject);
begin
  SelImg.Free;
  Table.Free;
end;


procedure TTableForm.ModalShow(ATable: TTable);
begin
  if ATable = nil then
    ATable := TTable.Create();

  AModTable := ATable;

  Table.Assign(AModTable);
  AssignGrid;
  AssignMeasuresGrid;
  Update;
  IsModal := true;
  Modified := false;
  ShowModal;
end;

procedure TTableForm.ModalHide(ATable: TTable);
begin
  if not IsModal then
    Exit;

  IsModal := false;
  AModTable.Assign(Table);

  if (ATable <> nil) and (ATable <> AModTable) then
    ATable.Assign(AModTable);

end;

procedure TTableForm.About1Click(Sender: TObject);
begin
  if AboutForm = nil then
  begin
    Application.CreateForm(TAboutForm, AboutForm);
    AboutForm.Memo.Lines.Insert(0, sApp);
    AboutForm.Memo.Lines.Insert(1, sAppVer);
  end;
  AboutForm.ShowModal;
end;

function LightenColor(C:TColor;D:LOngInt):TColor;
var R,G,B:byte;
begin
 R:=GetRValue(C);
 G:=GetGValue(C);
 B:=GetBValue(C);
 Result:=RGB(
   Max(0,(Min(255,R+D))),Max(0,(Min(255,G+D))),Max(0,(Min(255,B+D))));

end;

procedure TTableForm.GridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var R: TRect;
  S: string;
  flag, tw: dword;
begin
  with Grid do
  begin

    Canvas.Brush.Color := clWhite;
    tw := Canvas.TextWidth(Grid.Rows[Arow].Strings[ACol]);
    Flag := DT_RIGHT;
    R := Rect;
    //InflateRect(R, -1, -1);

    Canvas.Font.Name:='Arial';
    Canvas.Font.Style:=[];
    Canvas.Font.Color:=clBlack;
    Canvas.Font.Size:=10;

    if ((ACol = 1)and(ARow>1)) or ((ARow = 1)and(ACol>1))
       or((ACol = 1)and(ARow=1)) then
    begin
      Canvas.Brush.Color := clSilver;
      Canvas.FillRect(Rect);
      Flag := DT_CENTER;
      Canvas.Font.Style:=[fsBold];
      if GridLineWidth>0 then
       begin
        Canvas.Pen.Color:=clGray;
        Canvas.Pen.Width:=1;
        Canvas.MoveTo(Rect.Left,Rect.Bottom);
        Canvas.LineTo(Rect.Right,Rect.Bottom);
        Canvas.MoveTo(Rect.Right,Rect.Top);
        Canvas.LineTo(Rect.Right,Rect.Bottom);
       end;
    end
    else
     Canvas.FillRect(Rect); ;
   //   R := Classes.Rect(R.Right - tw, R.Top, R.Right, R.Bottom);


    SetBkMode(Canvas.Handle, Transparent);

    DrawText(Canvas.Handle, PChar(Grid.Rows[Arow].Strings[ACol]), -1, R, Flag);

    if gdFixed in State then
    begin
      Canvas.Brush.Color := clSkyBlue;
      Canvas.FillRect(Rect);
     // InflateRect(Rect, -1, -1);
     // Canvas.FrameRect(Rect);


      InflateRect(Rect, -1, -1);
      R := Rect;
      if ACol = 0 then
        S := IntToStr(ARow - 1)
      else
        S := IntToStr(ACol - 1);
      if (ACol = 0) and (ARow = 0) then S := '';
      SetBkMode(Canvas.Handle, Transparent);

      Canvas.Font.Style:=[fsBold];
      Canvas.Font.Color:=clBlack;
      Canvas.Font.Size:=11;


      DrawText(Canvas.Handle, PChar(S), -1, Rect, DT_CENTER);

       begin
        Canvas.Pen.Width:=1;
        Canvas.Pen.Color:=LightenColor(clSkyBlue,-150);
        Canvas.MoveTo(Rect.Left,Rect.Bottom);
        Canvas.LineTo(Rect.Right,Rect.Bottom);
        Canvas.MoveTo(Rect.Right,Rect.Top);
        Canvas.LineTo(Rect.Right,Rect.Bottom);

        Canvas.Pen.Color:=LightenColor(clSkyBlue,150);
        Canvas.MoveTo(Rect.Left,Rect.Top);
        Canvas.LineTo(Rect.Right,Rect.Top);
        Canvas.MoveTo(Rect.Left,Rect.Top);
        Canvas.LineTo(Rect.Left,Rect.Bottom);
       end;

    end;

    if gdSelected in State then
    begin
      Canvas.Brush.Color := clRed;

      Canvas.Pen.Color:=clRed;
      Canvas.Pen.Width:=2;

  {   // if not PtInRect(ACol-1,ARow,Grid.Selection)then
       begin
        Canvas.MoveTo(R.Left,R.Top-1);
        Canvas.LineTo(R.Left,R.Bottom);
       end;
     //  if not PtInRect(ACol+1,ARow,Grid.Selection)then
       begin
        Canvas.MoveTo(R.Right,R.Top-1);
        Canvas.LineTo(R.Right,R.Bottom);
       end;
     //  if not PtInRect(ACol,ARow-1,Grid.Selection)then
       begin
        Canvas.MoveTo(R.Left-1,R.Top);
        Canvas.LineTo(R.Right,R.Top);
       end;
     //  if not PtInRect(ACol,ARow+1,Grid.Selection)then
       begin
        Canvas.MoveTo(R.Left-1,R.Bottom);
        Canvas.LineTo(R.Right,R.Bottom);
       end;
     }
       Canvas.FrameRect(Rect);

       InflateRect(Rect,1,1);
       OffsetRect(Rect,1,1);
       SelImg.DrawAlpha(Canvas.Handle,Rect,SelImg.Bounds);



    end;
  end;
end;

function TTableForm.PtInRect(X,Y:LongInt;R:TGridRect):boolean;
begin
  Result:=(X>=R.Left)and(Y>=R.Top)and(X<=R.Right)and(Y<=R.Bottom);
end;

procedure TTableForm.PropEditValidate(Sender: TObject; ACol, ARow: Integer;
  const KeyName, KeyValue: string);
begin

  if CompStr(KeyName, 'Table Name') then Table.Name := KeyValue;

  if CompStr(KeyName, 'Rows') then
  begin
    if KeyValue <> '' then
      Table.RowCount := StrToInt(KeyValue);
    PropEdit.Values[KeyName] := IntToStr(Table.RowCount);
    AssignGrid;
  end;

  if CompStr(KeyName, 'Columns') then
  begin
    if KeyValue <> '' then
      Table.ColCount := StrToInt(KeyValue);
    PropEdit.Values[KeyName] := IntToStr(Table.ColCount);
    AssignGrid;
  end;


end;

procedure TTableForm.AssignMeasuresTab;
var i: LongInt;
begin
  for i := 0 to Table.ColCount - 1 do
    Table.ColWidths[i] := Grid.ColWidths[i + 1];

  for i := 0 to Table.RowCount - 1 do
    Table.RowHeights[i] := Grid.RowHeights[i + 1];

  Table.Comment.Assign(Comments.Lines);

end;

procedure TTableForm.AssignMeasuresGrid;
var i: LongInt;
begin
  for i := 0 to Table.ColCount - 1 do
    Grid.ColWidths[i + 1] := Table.ColWidths[i];

  for i := 0 to Table.RowCount - 1 do
    Grid.RowHeights[i + 1] := Table.RowHeights[i];


  Comments.Lines.Assign(Table.Comment);
end;

procedure TTableForm.ResetMeasures;
begin
  Table.SetDefaultMeasures;
  AssignMeasuresGrid;
end;


procedure TTableForm.PropEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
    PropEditValidate(Self, PropEdit.Col, PropEdit.Row,
      PropEdit.Keys[PropEdit.Row],
      PropEdit.Values[PropEdit.Keys[PropEdit.Row]]);

end;

procedure TTableForm.SaveAsClick(Sender: TObject);
begin
  SaveD.FileName := Filename;
  if SaveD.Execute then
  begin
    Assigntable;
    AssignMeasuresTab;
    Table.SaveToFile(SaveD.FileName);
    FileName := SaveD.Filename;
    Update;
  end;

end;

procedure TTableForm.AssignTable;
var ix, iy: Longint;
begin

  for ix := 0 to Table.ColCount - 1 do
    for iy := 0 to Table.RowCount - 1 do
      Table.CellsIdx[ix, iy] := Grid.Cells[ix + 1, iy + 1];


end;


procedure TTableForm.AssignGrid;
var ix, iy: Longint;
begin
  Grid.RowCount := Table.RowCount + 1;
  Grid.ColCount := Table.ColCount + 1;


  for ix := 0 to Table.ColCount - 1 do
    for iy := 0 to Table.RowCount - 1 do
      Grid.Cells[ix + 1, iy + 1] := Table.CellsIdx[ix, iy];

end;

procedure TTableForm.OpenClick(Sender: TObject);
begin

  if OpenD.Execute then
  begin
    Table.LoadFromFile(OpenD.Filename);
    AssignGrid;
    AssignMeasuresGrid;
    Filename := OpenD.FileName;
    Update;
    Modified := false;
  end;

end;

procedure TTableForm.Exit1Click(Sender: TObject);
begin
//  SaveClick(nil);
  Close;
end;

procedure TTableForm.SaveClick(Sender: TObject);
begin
  AssignTable;
  AssignMeasuresTab;
  if not CompStr(Filename, sUntit) then
    Table.SaveToFile(Filename)
  else
    SaveAsClick(nil);


end;

procedure TTableForm.New1Click(Sender: TObject);
begin
  if Modified then
    case MessageDlg('File was modified' + #10 + 'Save it before new file is created?',
      mtConfirmation, mbYesNoCancel, 0) of
      mrYes: SaveClick(Self);
      mrCancel: Exit;
      mrNo:
    end;

  Table.Free;
  Table := TTable.Create;
  AssignGrid;
  ResetMeasures;
  Modified:=false;
  Filename := sUntit;
  Update;

end;

procedure TTableForm.Update;
begin
  TableForm.Caption := ExtractFilename(Filename) + ' - ' + sApp;

  PropEdit.Values['Table Name'] := Table.Name;
  PropEdit.Values['Rows'] := IntToStr(Table.RowCount);
  PropEdit.Values['Columns'] := IntToStr(Table.ColCount);

  CheckCompress.Checked := Table.Compress;
  

  UpdatePos;
end;

procedure TTableForm.UpdatePos;
begin
  AssignTable;

  if (Grid.Selection.Left = Grid.Selection.Right)
    and (Grid.Selection.Top = Grid.Selection.Bottom) then
    SelPanel.Caption := Format('C%d:R%d', [Grid.Col - 1, Grid.Row - 1])
  else
    SelPanel.Caption := Format('C%d:R%d x C%d:R%d', [
      Grid.Selection.Left - 1, Grid.Selection.Top - 1, Grid.Selection.Right - 1,
        Grid.Selection.Bottom - 1]);

end;


procedure TTableForm.RegFile;
var
  Reg: TRegistry;
begin
  if not CompStr(ChangeFileExt(ExtractFileName(ParamStr(0)), ''), 'TableMgr')
    then
    Exit;

  Reg := TRegistry.Create;
  REg.Rootkey := HKEY_CLASSES_ROOT;
  Reg.OpenKey('.vdt', true);
  Reg.WriteString('', 'Vampyre Data Table');
  Reg.Closekey;

  Reg.OpenKey('Vampyre Data Table\DefaultIcon', true);
  Reg.WriteString('', Application.ExeName + ',1');
  Reg.Closekey;
  Reg.OpenKey('Vampyre Data Table', true);
  Reg.WriteString('', 'Vampyre Data Table');
  Reg.Closekey;
  Reg.OpenKey('Vampyre Data Table\Shell', true);
  Reg.WriteString('', 'Otevt');
  Reg.OpenKey('otevt', true);
  Reg.OpenKey('command', true);
  Reg.WriteString('', Application.ExeName + ' "%1"');
  Reg.Closekey;
  Reg.Free;

end;

procedure TTableForm.GridKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  AssignTable;

  if not (Key in [VK_LEFT..VK_DOWN]) then
    Grid.Options := Grid.Options + [goEditing];

  if not (Key in [VK_LEFT..VK_DOWN, VK_RETURN, VK_F2, VK_CONTROL, VK_SHIFT,
    VK_MENU, VK_SPACE, VK_PRIOR, VK_NEXT]) then Modified := true;

  case Key of

    VK_LEFT:
      begin
        if not Editing and Grid.EditorMode then
        begin
          Grid.EditorMode := false;
          Grid.Selection := CheckGR(SetGridPt(Grid.Col - 1, Grid.Row));
        end;
      end;

    VK_RIGHT:
      begin
        if not Editing and Grid.EditorMode then
        begin
          Grid.EditorMode := false;
          Grid.Selection := CheckGR(SetGridPt(Grid.Col + 1, Grid.Row));
        end;
      end;

    VK_F2: Editing := true;

    VK_RETURN:
      begin
        if not Grid.EditorMode then
          Editing := true;



      end;

    //Ord('C'):
      //if ssCtrl in Shift then CopySel;

   // Ord('X'):
     // if ssCtrl in Shift then Cut;

    //Ord('V'):
      //if ssCtrl in Shift then Paste;
    VK_INSERT:
      if ssShift in Shift then
        Paste
      else
        if ssCtrl in Shift then CopySel;

    VK_DELETE:DeleteSel;


  end;


end;

procedure TTableForm.GridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
//
  Grid.Options := Grid.Options - [goEditing];
  Editing := false;

end;

procedure TTableForm.GridMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  UpdatePos;
end;

procedure TTableForm.GridKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  UpdatePos;
end;

procedure TTableForm.GridMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then
  begin
    UpdatePos;

  end;
end;



function TTableForm.GridRect(c1, r1, c2, r2: LongInt): TGridRect;
begin
  with Result do
  begin
    Left := c1;
    Top := r1;
    Right := c2;
    Bottom := r2;

  end;
end;


function TTableForm.SetGridPt(c, r: LongInt): TGridRect;
begin
  Result := GridRect(c, r, c, r);

end;

function TTableForm.CheckGR(R: TGridRect): TGridRect;
begin
  with Result do
  begin
    Left := Max(1, Min(R.Left, Table.ColCount));
    Right := Max(1, Min(R.Right, Table.ColCount));
    Top := Max(1, Min(R.Top, Table.RowCount));
    Bottom := Max(1, Min(R.Bottom, Table.RowCount));
  end;
end;


procedure TTableForm.GridDblClick(Sender: TObject);
begin
  Editing := true;
  Grid.Options := Grid.Options + [goEditing];
  Grid.EditorMode := true;
end;

procedure TTableForm.GridClick(Sender: TObject);
begin
  Grid.Options := Grid.Options - [goEditing];

end;

procedure TTableForm.DeleteSel;
var x, y: LongInt;
begin


  if not Grid.EditorMode then
  begin
    for X := Grid.Selection.Left to Grid.Selection.Right do
      for Y := Grid.Selection.Top to Grid.Selection.Bottom do
        Grid.Cells[x, y] := '';
    AssignTable;
  end;

end;





procedure TTableForm.Cut;
begin
  CopySel;
  DeleteSel;
end;

procedure TTableForm.CopySel;
var x, y: LongInt;
begin
  StoreArr := nil;
  Store := '';

  if (Grid.Selection.Left = Grid.Selection.Right) and
    (Grid.Selection.Top = Grid.Selection.Bottom) then
    Store := Grid.Cells[Grid.Col, Grid.Row]

  else
    with Grid.Selection do
    begin
      Setlength(StoreArr, Grid.Selection.Right - Grid.Selection.Left + 1,
        Grid.Selection.Bottom - Grid.Selection.Top + 1);
      for x := Grid.Selection.Left to Grid.Selection.Right do
        for y := Grid.Selection.Top to Grid.Selection.Bottom do
          StoreArr[x - Grid.Selection.Left, y - Grid.Selection.Top] :=
            Grid.Cells[x, y]


    end;


end;

procedure TTableForm.Paste;
var x, y, dx, dy: LongInt;
begin
  if (Store <> '') and (StoreArr = nil) then
    Grid.Cells[Grid.Col, Grid.Row] := Store
  else
    if StoreArr <> nil then
      with Grid.Selection do
      begin
        dx := Length(StoreArr);
        dy := Length(StoreArr[0]);


        for x := 0 to dx - 1 do
          for y := 0 to dy - 1 do
            Grid.Cells[x + Grid.Selection.Left, y + Grid.Selection.Top] :=
              StoreArr[x, y];
      end;

end;

procedure TTableForm.GridColumnMoved(Sender: TObject; FromIndex,
  ToIndex: Integer);
begin
  UpdatePos;
end;

procedure TTableForm.GridRowMoved(Sender: TObject; FromIndex, ToIndex: Integer);
begin
  UpdatePos;
end;

procedure TTableForm.CheckCompressClick(Sender: TObject);
begin
  Table.Compress := CheckCompress.Checked;
end;

procedure TTableForm.Button1Click(Sender: TObject);
begin
  ResetMeasures;
end;


procedure TTableForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if (Modified) and (not IsModal) then
    case MessageDlg('File was modified' + #10 + 'Save it before exiting?',
      mtWarning, mbYesNoCancel, 0) of

      mrYes: SaveClick(Self);
      mrCancel: CanClose := false;
      mrNo:
    end;

end;

procedure TTableForm.Copy1Click(Sender: TObject);
begin
  CopySel;
end;

procedure TTableForm.Paste1Click(Sender: TObject);
begin
  Paste;
end;

procedure TTableForm.Cut1Click(Sender: TObject);
begin
  Cut;
end;

procedure TTableForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if (Action in [caNone..caFree]) and IsModal then
    ModalHide;
end;

procedure TTableForm.Print1Click(Sender: TObject);
begin
  PrintD.Execute;
end;

procedure TTableForm.Find1Click(Sender: TObject);
begin
  FindPos := 0;
  FindD.Execute;
end;

procedure TTableForm.FindText(Sender: TObject);
var X, Y: LongInt;
  Found: boolean;
begin
  Found := false;

  for X := 0 to Table.ColCount - 1 do
    for Y := 0 to Table.RowCount - 1 do
    begin
      if Y * Table.ColCount + X < FindPos then Continue;

      case frMatchCase in FindD.Options of
        true:
          if AnsiContainsStr(Table.CellsIdx[X, Y], TFindDialog(Sender).FindText) then
            Found := true;
        false:
          if AnsiContainsText(Table.CellsIdx[X, Y], TFindDialog(Sender).FindText) then
            Found := true;
      end;

      if Found then
      begin
        Grid.Selection := TGridRect(Rect(X + 1, Y + 1, X + 1, Y + 1));
        FindPos := Y * Table.ColCount + X + 1;
        Exit;
      end;

    end;

  MessageDlg('You have reached end of file.', mtInformation, [mbOK], 0);
  TFindDialog(Sender).CloseDialog;

end;




procedure TTableForm.Replace1Click(Sender: TObject);
begin
FindPos:=0;
ReplaceD.Execute;
end;

procedure TTableForm.ReplaceDReplace(Sender: TObject);
var X, Y: LongInt;
  Found: boolean;
begin
//


  for X := 0 to Table.ColCount - 1 do
    for Y := 0 to Table.RowCount - 1 do
    begin
      Found := false;

      if Y * Table.ColCount + X < FindPos then Continue;

      case frMatchCase in FindD.Options of
        true:
          if AnsiContainsStr(Table.CellsIdx[X, Y], ReplaceD.FindText) then
            Found := true;
        false:
          if AnsiContainsText(Table.CellsIdx[X, Y], ReplaceD.FindText) then
            Found := true;
      end;

      if Found then
      begin
        Grid.Selection := TGridRect(Rect(X + 1, Y + 1, X + 1, Y + 1));
        case frMatchCase in ReplaceD.Options of
        true:
          Table.CellsIdx[X, Y]:=
          AnsiReplaceStr(Table.CellsIdx[X, Y], ReplaceD.FindText,ReplaceD.ReplaceText);
        false:
           Table.CellsIdx[X, Y]:=
           AnsiReplaceText(Table.CellsIdx[X, Y], ReplaceD.FindText,ReplaceD.ReplaceText);
        end;
        Modified:=true;
        FindPos := Y * Table.ColCount + X + 1;
        Grid.Cells[X+1,Y+1]:=Table.CellsIdx[X,Y];
        if not(frReplaceAll in ReplaceD.Options) then
        Exit;
      end;

    end;

  MessageDlg('You have reached end of file.', mtInformation, [mbOK], 0);
  TFindDialog(Sender).CloseDialog;



end;

procedure TTableForm.ExportTextClick(Sender: TObject);
begin
ExportTable(etText);
end;

procedure TTableForm.ExportTable(Exp:TExportTable);
const Filters:array[TExportTable]of string=
      ('Text File(*.txt) | *.txt','Excel XP CSV(*.csv) | *.csv',
       'Excel 97/2000 CSV(*.csv) | *.csv');
      Exts:array[TExportTable]of string=
      ('txt','csv','csv');


begin
ExportD.Filter:=Filters[Exp];
ExportD.DefaultExt:=exts[Exp];
if not ExportD.Execute then
 Exit;

 case Exp of
 etText:Table.ExportTextFile(ExportD.FileName);
 etCSVXP:Table.ExportCSVXP(ExportD.FileName);
 etCSV97:Table.ExportCSV2K(ExportD.FileName);

 end;


end;

procedure TTableForm.ExcelXPCSVfile1Click(Sender: TObject);
begin
ExportTable(etCSVXP);
end;

procedure TTableForm.Excel972000CSVfile1Click(Sender: TObject);
begin
ExportTable(etCSV97);
end;

procedure TTableForm.SetsEditValidate(Sender: TObject; ACol, ARow: Integer;
  const KeyName, KeyValue: String);
begin
//
end;

procedure TTableForm.Delete1Click(Sender: TObject);
begin
DeleteSel;
end;

procedure TTableForm.SpeedButton6Click(Sender: TObject);
begin
New1Click(Self);
end;

procedure TTableForm.SpeedButton7Click(Sender: TObject);
begin
OpenClick(Self);
end;

procedure TTableForm.SpeedButton8Click(Sender: TObject);
begin
SaveClick(Self);

end;

procedure TTableForm.SpeedButton9Click(Sender: TObject);
begin
Print1Click(Self);

end;

procedure TTableForm.SpeedButton10Click(Sender: TObject);
begin
Exit1Click(Self);

end;

procedure TTableForm.SpeedButton3Click(Sender: TObject);
begin
Cut1Click(Self);

end;

procedure TTableForm.SpeedButton4Click(Sender: TObject);
begin
Copy1Click(Self);

end;

procedure TTableForm.SpeedButton5Click(Sender: TObject);
begin
Paste1Click(Self);

end;

procedure TTableForm.SpeedButton11Click(Sender: TObject);
begin
Delete1Click(Self);

end;

procedure TTableForm.SpeedButton12Click(Sender: TObject);
begin
Find1Click(nil);
end;

procedure TTableForm.SpeedButton13Click(Sender: TObject);
begin
Replace1Click(nil);
end;

procedure TTableForm.SpeedButton14Click(Sender: TObject);
begin
 ResetMeasures;
end;

procedure TTableForm.SpdTogglePagesClick(Sender: TObject);
begin
// code below works very well
SpdTogglePages.Down:=SpdTogglePages.Down;
Pages.Visible:=SpdTogglePages.Down;

end;

procedure TTableForm.GridMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
case Button Of
mbRight:
begin
Pages.Visible:=not Pages.Visible;
SpdTogglePages.Down:=not SpdTogglePages.Down;
end;

end;
end;

end.

